Option Strict Off
Option Explicit On
Friend Class CProjekte
	Public m_projekte As New Collection ' Additional projects
	Public m_folderProjekte As MAPI.Folder ' Projekt folder
	
	
	' Return a list of all projects, the text names and all elements from the project folder
	Public Function GetProjects() As Collection
		Dim c As New Collection
		Dim s As String
		Dim i As Short
		Dim obj As Object
		For i = 1 To m_projekte.Count()
			'UPGRADE_WARNING: Couldn't resolve default property of object m_projekte.Item(). Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			s = m_projekte.Item(i)
			c.Add(s)
		Next i
		If Not (m_folderProjekte Is Nothing) Then
			'UPGRADE_WARNING: Couldn't resolve default property of object m_folderProjekte.Items. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			For	Each obj In m_folderProjekte.Items
				'UPGRADE_WARNING: Couldn't resolve default property of object obj.Subject. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				c.Add(obj.Subject)
			Next obj
		End If
		GetProjects = c
	End Function
	
	' Open the configuration message or create a new one.
	' we create a message in the hidden message of our inbox, the body contains all projects
	Public Function ConfigMsg() As MAPI.Message
		Dim msg As MAPI.Message
		Dim inbox As MAPI.Folder
		Dim msgs As MAPI.Messages
		Dim session As New MAPI.Session
		session.MAPIOBJECT = OutlookApplication_definst.Application.GetNamespace("MAPI").MAPIOBJECT
		inbox = session.GetDefaultFolder(MAPI.CdoDefaultFolderTypes.CdoDefaultFolderInbox)
		msgs = inbox.HiddenMessages
		For	Each msg In msgs
			If msg.Subject = "Projects" Then
				ConfigMsg = msg
				Exit For
			End If
		Next msg
		If ConfigMsg Is Nothing Then
			msg = msgs.Add("Projects")
			'UPGRADE_WARNING: Couldn't resolve default property of object msg.fields().Value. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			msg.fields(MAPI.CdoPropTags.CdoPR_MESSAGE_CLASS).Value = "IPM.Project"
			ConfigMsg = msg
		End If
	End Function
	
	Public Sub Save()
		Dim fields As MAPI.Fields
		Dim field As MAPI.Field
		Dim config As MAPI.Message
		Dim s As String
		Dim i As Short
		Dim line As String
		For i = 1 To m_projekte.Count()
			'UPGRADE_WARNING: Couldn't resolve default property of object m_projekte.Item(). Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			line = m_projekte.Item(i)
			s = s & line & vbCr
		Next i
		config = ConfigMsg
		If Not m_folderProjekte Is Nothing Then
			fields = config.fields
			'UPGRADE_NOTE: Object field may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
			field = Nothing
			On Error Resume Next
			field = fields.Item("projectfolder")
			On Error GoTo 0
			If field Is Nothing Then field = fields.Add("projectfolder", MAPI.CdoFieldType.CdoString)
			'UPGRADE_WARNING: Couldn't resolve default property of object m_folderProjekte.EntryID. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			field.Value = m_folderProjekte.EntryID
		End If
		config.text = s
		config.Update()
	End Sub
	
	Public Sub Load()
		Dim id As Object
		Dim fields As Object
		Dim field As Object
		Dim p As Object
		Dim config As MAPI.Message
		Dim text As String
		Dim s As String
		config = ConfigMsg
		If Not (config Is Nothing) Then
			'UPGRADE_WARNING: Couldn't resolve default property of object config.text. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			text = config.text
			Do 
				'UPGRADE_WARNING: Couldn't resolve default property of object p. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				p = InStr(1, text, vbCr)
				'UPGRADE_WARNING: Couldn't resolve default property of object p. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				If p = 0 Then
					m_projekte.Add(text)
					Exit Do
				Else
					'UPGRADE_WARNING: Couldn't resolve default property of object p. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
					s = Left(text, p - 1)
					'UPGRADE_WARNING: Couldn't resolve default property of object p. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
					text = Mid(text, p + 1)
				End If
				m_projekte.Add(s)
			Loop 
			On Error Resume Next
			'UPGRADE_NOTE: Object field may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
			field = Nothing
			fields = config.fields
			'UPGRADE_WARNING: Couldn't resolve default property of object fields.Item. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			field = fields.Item("projectfolder")
			On Error GoTo 0
			If Not (field Is Nothing) Then
				On Error Resume Next
				'UPGRADE_WARNING: Couldn't resolve default property of object field.Value. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				'UPGRADE_WARNING: Couldn't resolve default property of object id. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				id = field.Value
				'UPGRADE_WARNING: Couldn't resolve default property of object id. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				m_folderProjekte = OutlookApplication_definst.Application.GetNamespace("MAPI").GetFolderFromID(id)
				On Error GoTo 0
			End If
		End If
		
		
	End Sub
	
	Public Sub Init()
		If m_projekte.Count() = 0 Then Load()
	End Sub
	'UPGRADE_NOTE: Class_Initialize was upgraded to Class_Initialize_Renamed. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
	Private Sub Class_Initialize_Renamed()
		'UPGRADE_NOTE: Object m_folderProjekte may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
		m_folderProjekte = Nothing
		Load()
	End Sub
	Public Sub New()
		MyBase.New()
		Class_Initialize_Renamed()
	End Sub
End Class